Subject: Re: [patch v7 3/4] USB: add Cypress c67x00 OTG controller HCD driver

From: David Brownell <[email-masked]>
Date: Wed, 20 Feb 2008 10:07:01 -0800

On Wednesday 20 February 2008, Greg KH wrote:
> >  Greg> Can you move the files under the hcd/ subdir
> 
> Oops, I ment "host/" not, "hcd/".
> 
> > Sorry, I don't think that's a good idea as the hardware can do
> > peripheral as well, and as you can see in patch 4, a gadget driver is
> > on it's way.
> 
> Ok, that's fine, why can't the gadget stuff go into the gadget/
> directory then also?  As this device is a host controller, it makes
> sense to me to keep it in the host-controller subdirectory.

FWIW we did the same thing with drivers/usb/musb (for the Mentor
highspeed OTG core) ... the basic issue is that the host and
peripheral sides of the hardware aren't split like that.  There
would be lots of code sharing (FIFO access, IRQ handling, DMA,
initialization, come quickly to mind) between HCD and gadget
sides.  Enough that trying to create an artificial split between
those -- and let it coordinate properly in OTG modes -- seemed
like a waste of effort.

- Dave